Faiss

- Main Page
- Namespaces
- Classes
- Files

- File List

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends
/data/users/matthijs/github_faiss/faiss/ProductQuantizer.h
1 /**
2 * Copyright (c) 2015-present, Facebook, Inc.
3 * All rights reserved.
4 *
5 * This source code is licensed under the BSD+Patents license found in the
6 * LICENSE file in the root directory of this source tree.
7 */
8
9 // Copyright 2004-present Facebook. All Rights Reserved.
10 // -*- c++ -*-
11
12 #ifndef FAISS_PRODUCT_QUANTIZER_H
13 #define FAISS_PRODUCT_QUANTIZER_H
14
15 #include <stdint.h>
16
17 #include <vector>
18
19 #include "Clustering.h"
20 #include "Heap.h"
21
22 namespace faiss {
23
24 /** Product Quantizer. Implemented only for METRIC_L2 */
25 struct ProductQuantizer {
26
27 size_t d; ///< size of the input vectors
28 size_t M; ///< number of subquantizers
29 size_t nbits; ///< number of bits per quantization index
30
31 // values derived from the above
32 size_t dsub; ///< dimensionality of each subvector
33 size_t byte_per_idx; ///< nb bytes per code component (1 or 2)
34 size_t code_size; ///< byte per indexed vector
35 size_t ksub; ///< number of centroids for each subquantizer
36 bool verbose; ///< verbose during training?
37
38
39 /// initialization
40 enum train_type_t {
41 Train_default,
42 Train_hot_start, ///< the centroids are already initialized
43 Train_shared, ///< share dictionary accross PQ segments
44 Train_hypercube, ///< intialize centroids with nbits-D hypercube
45 Train_hypercube_pca, ///< intialize centroids with nbits-D hypercube
46 };
47 train_type_t train_type;
48
49 ClusteringParameters cp; ///< parameters used during clustering
50
51 /// Centroid table, size M * ksub * dsub
52 std::vector<float> centroids;
53
54 /// return the centroids associated with subvector m
55 float * get_centroids (size_t m, size_t i) {
56 return &centroids [(m * ksub + i) * dsub];
57 }
58 const float * get_centroids (size_t m, size_t i) const {
59 return &centroids [(m * ksub + i) * dsub];
60 }
61
62 // Train the product quantizer on a set of points. A clustering
63 // can be set on input to define non-default clustering parameters
64 void train (int n, const float *x);
65
66 ProductQuantizer(size_t d, /* dimensionality of the input vectors */
67 size_t M, /* number of subquantizers */
68 size_t nbits); /* number of bit per subvector index */
69
70 ProductQuantizer ();
71
72 /// compute derived values when d, M and nbits have been set
73 void set_derived_values ();
74
75 /// Define the centroids for subquantizer m
76 void set_params (const float * centroids, int m);
77
78 /// Quantize one vector with the product quantizer
79 void compute_code (const float * x, uint8_t * code) const ;
80
81 /// same as compute_code for several vectors
82 void compute_codes (const float * x,
83 uint8_t * codes,
84 size_t n) const ;
85
86 /// decode a vector from a given code (or n vectors if third argument)
87 void decode (const uint8_t *code, float *x) const;
88 void decode (const uint8_t *code, float *x, size_t n) const;
89
90 /// If we happen to have the distance tables precomputed, this is
91 /// more efficient to compute the codes.
92 void compute_code_from_distance_table (const float *tab,
93 uint8_t *code) const;
94
95
96 /** Compute distance table for one vector.
97 *
98 * The distance table for x = [x_0 x_1 .. x_(M-1)] is a M * ksub
99 * matrix that contains
100 *
101 * dis_table (m, j) = || x_m - c_(m, j)||^2
102 * for m = 0..M-1 and j = 0 .. ksub - 1
103 *
104 * where c_(m, j) is the centroid no j of sub-quantizer m.
105 *
106 * @param x input vector size d
107 * @param dis_table output table, size M * ksub
108 */
109 void compute_distance_table (const float * x,
110 float * dis_table) const;
111
112 void compute_inner_prod_table (const float * x,
113 float * dis_table) const;
114
115
116 /** compute distance table for several vectors
117 * @param nx nb of input vectors
118 * @param x input vector size nx * d
119 * @param dis_table output table, size nx * M * ksub
120 */
121 void compute_distance_tables (size_t nx,
122 const float * x,
123 float * dis_tables) const;
124
125 void compute_inner_prod_tables (size_t nx,
126 const float * x,
127 float * dis_tables) const;
128
129
130 /** perform a search (L2 distance)
131 * @param x query vectors, size nx * d
132 * @param nx nb of queries
133 * @param codes database codes, size ncodes * byte_per_idx
134 * @param ncodes nb of nb vectors
135 * @param res heap array to store results (nh == nx)
136 * @param init_finalize_heap initialize heap (input) and sort (output)?
137 */
138 void search (const float * x,
139 size_t nx,
140 const uint8_t * codes,
141 const size_t ncodes,
142 float_maxheap_array_t *res,
143 bool init_finalize_heap = true) const;
144
145 /** same as search, but with inner product similarity */
146 void search_ip (const float * x,
147 size_t nx,
148 const uint8_t * codes,
149 const size_t ncodes,
150 float_minheap_array_t *res,
151 bool init_finalize_heap = true) const;
152
153
154 /// Symmetric Distance Table
155 std::vector<float> sdc_table;
156
157 // intitialize the SDC table from the centroids
158 void compute_sdc_table ();
159
160 void search_sdc (const uint8_t * qcodes,
161 size_t nq,
162 const uint8_t * bcodes,
163 const size_t ncodes,
164 float_maxheap_array_t * res,
165 bool init_finalize_heap = true) const;
166
167 };
168
169
170
171 } // namespace faiss
172
173
174 #endif
faiss::ProductQuantizer::set_params
void set_params(const float *centroids, int m)
Define the centroids for subquantizer m.
Definition: ProductQuantizer.cpp:179
faiss::ProductQuantizer::Train_hypercube_pca
intialize centroids with nbits-D hypercube
Definition: ProductQuantizer.h:45
faiss::ProductQuantizer::nbits
size_t nbits
number of bits per quantization index
Definition: ProductQuantizer.h:29
faiss::ProductQuantizer::decode
void decode(const uint8_t *code, float *x) const
decode a vector from a given code (or n vectors if third argument)
Definition: ProductQuantizer.cpp:338
faiss::ProductQuantizer::byte_per_idx
size_t byte_per_idx
nb bytes per code component (1 or 2)
Definition: ProductQuantizer.h:33
faiss::ProductQuantizer::Train_hypercube
intialize centroids with nbits-D hypercube
Definition: ProductQuantizer.h:44
faiss::ProductQuantizer::set_derived_values
void set_derived_values()
compute derived values when d, M and nbits have been set
Definition: ProductQuantizer.cpp:166
faiss::ProductQuantizer::sdc_table
std::vector< float > sdc_table
Symmetric Distance Table.
Definition: ProductQuantizer.h:155
faiss::ProductQuantizer::Train_shared
share dictionary accross PQ segments
Definition: ProductQuantizer.h:43
faiss::ProductQuantizer::dsub
size_t dsub
dimensionality of each subvector
Definition: ProductQuantizer.h:32
faiss::ProductQuantizer::compute_distance_tables
void compute_distance_tables(size_t nx, const float *x, float *dis_tables) const
Definition: ProductQuantizer.cpp:439
faiss::ProductQuantizer::compute_code_from_distance_table
void compute_code_from_distance_table(const float *tab, uint8_t *code) const
Definition: ProductQuantizer.cpp:363
faiss::ProductQuantizer::compute_codes
void compute_codes(const float *x, uint8_t *codes, size_t n) const
same as compute_code for several vectors
Definition: ProductQuantizer.cpp:385
faiss::ProductQuantizer::compute_distance_table
void compute_distance_table(const float *x, float *dis_table) const
Definition: ProductQuantizer.cpp:410
faiss::ProductQuantizer::search
void search(const float *x, size_t nx, const uint8_t *codes, const size_t ncodes, float_maxheap_array_t *res, bool init_finalize_heap=true) const
Definition: ProductQuantizer.cpp:540
faiss::ProductQuantizer::code_size
size_t code_size
byte per indexed vector
Definition: ProductQuantizer.h:34
faiss::ProductQuantizer::ksub
size_t ksub
number of centroids for each subquantizer
Definition: ProductQuantizer.h:35
faiss::HeapArray
Definition: Heap.h:350
faiss::ProductQuantizer::search_ip
void search_ip(const float *x, size_t nx, const uint8_t *codes, const size_t ncodes, float_minheap_array_t *res, bool init_finalize_heap=true) const
Definition: ProductQuantizer.cpp:565
faiss::ProductQuantizer::compute_code
void compute_code(const float *x, uint8_t *code) const
Quantize one vector with the product quantizer.
Definition: ProductQuantizer.cpp:311
faiss::ProductQuantizer::Train_hot_start
the centroids are already initialized
Definition: ProductQuantizer.h:42
faiss::ProductQuantizer::cp
ClusteringParameters cp
parameters used during clustering
Definition: ProductQuantizer.h:49
faiss::ClusteringParameters
Definition: Clustering.h:24
faiss::ProductQuantizer::M
size_t M
number of subquantizers
Definition: ProductQuantizer.h:28
faiss::ProductQuantizer
Definition: ProductQuantizer.h:25
faiss::ProductQuantizer::get_centroids
float * get_centroids(size_t m, size_t i)
return the centroids associated with subvector m
Definition: ProductQuantizer.h:55
faiss::ProductQuantizer::d
size_t d
size of the input vectors
Definition: ProductQuantizer.h:27
faiss::ProductQuantizer::verbose
bool verbose
verbose during training?
Definition: ProductQuantizer.h:36
faiss::ProductQuantizer::centroids
std::vector< float > centroids
Centroid table, size M * ksub * dsub.
Definition: ProductQuantizer.h:52
faiss::ProductQuantizer::train_type_t
train_type_t
initialization
Definition: ProductQuantizer.h:40